## Autogenerated - do not edit

##' @describeIn Distributions AD implementation of \link[stats]{dexp}
setMethod("dexp",
signature(x = "ad", rate = "ad.", log = "logical."),
function( x, rate, log ) {
x <-  advector ( x )
rate <-  advector ( rate )
log <-  as.logical ( log )
distr_dexp ( x, rate, log )
}
)
##' @describeIn Distributions Default method
setMethod("dexp",
signature(x = "num", rate = "num.", log = "logical."),
function( x, rate, log ) {
stats:: dexp ( x=x, rate=rate, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dexp", "osa",
function( x, rate, log ) {
  dGenericOSA( "dexp" , x=x, rate=rate, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dexp", "simref",
function( x, rate, log ) {
  dGenericSim( "dexp" , x=x, rate=rate, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{dweibull}
setMethod("dweibull",
signature(x = "ad", shape = "ad", scale = "ad.", log = "logical."),
function( x, shape, scale, log ) {
x <-  advector ( x )
shape <-  advector ( shape )
scale <-  advector ( scale )
log <-  as.logical ( log )
distr_dweibull ( x, shape, scale, log )
}
)
##' @describeIn Distributions Default method
setMethod("dweibull",
signature(x = "num", shape = "num", scale = "num.", log = "logical."),
function( x, shape, scale, log ) {
stats:: dweibull ( x=x, shape=shape, scale=scale, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dweibull", "osa",
function( x, shape, scale, log ) {
  dGenericOSA( "dweibull" , x=x, shape=shape, scale=scale, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dweibull", "simref",
function( x, shape, scale, log ) {
  dGenericSim( "dweibull" , x=x, shape=shape, scale=scale, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{dbinom}
setMethod("dbinom",
signature(x = "ad", size = "ad", prob = "ad", log = "logical."),
function( x, size, prob, log ) {
x <-  advector ( x )
size <-  advector ( size )
prob <-  advector ( prob )
log <-  as.logical ( log )
distr_dbinom ( x, size, prob, log )
}
)
##' @describeIn Distributions Default method
setMethod("dbinom",
signature(x = "num", size = "num", prob = "num", log = "logical."),
function( x, size, prob, log ) {
stats:: dbinom ( x=x, size=size, prob=prob, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dbinom", "osa",
function( x, size, prob, log ) {
  dGenericOSA( "dbinom" , x=x, size=size, prob=prob, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dbinom", "simref",
function( x, size, prob, log ) {
  dGenericSim( "dbinom" , x=x, size=size, prob=prob, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{dbeta}
setMethod("dbeta",
signature(x = "ad", shape1 = "ad", shape2 = "ad", ncp = "missing", log = "logical."),
function( x, shape1, shape2, log ) {
x <-  advector ( x )
shape1 <-  advector ( shape1 )
shape2 <-  advector ( shape2 )
log <-  as.logical ( log )
distr_dbeta ( x, shape1, shape2, log )
}
)
##' @describeIn Distributions Default method
setMethod("dbeta",
signature(x = "num", shape1 = "num", shape2 = "num", ncp = "missing", log = "logical."),
function( x, shape1, shape2, log ) {
stats:: dbeta ( x=x, shape1=shape1, shape2=shape2, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dbeta", "osa",
function( x, shape1, shape2, log ) {
  dGenericOSA( "dbeta" , x=x, shape1=shape1, shape2=shape2, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dbeta", "simref",
function( x, shape1, shape2, log ) {
  dGenericSim( "dbeta" , x=x, shape1=shape1, shape2=shape2, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{df}
setMethod("df",
signature(x = "ad", df1 = "ad", df2 = "ad", ncp = "missing", log = "logical."),
function( x, df1, df2, log ) {
x <-  advector ( x )
df1 <-  advector ( df1 )
df2 <-  advector ( df2 )
log <-  as.logical ( log )
distr_df ( x, df1, df2, log )
}
)
##' @describeIn Distributions Default method
setMethod("df",
signature(x = "num", df1 = "num", df2 = "num", ncp = "missing", log = "logical."),
function( x, df1, df2, log ) {
stats:: df ( x=x, df1=df1, df2=df2, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("df", "osa",
function( x, df1, df2, log ) {
  dGenericOSA( "df" , x=x, df1=df1, df2=df2, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("df", "simref",
function( x, df1, df2, log ) {
  dGenericSim( "df" , x=x, df1=df1, df2=df2, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{dlogis}
setMethod("dlogis",
signature(x = "ad", location = "ad.", scale = "ad.", log = "logical."),
function( x, location, scale, log ) {
x <-  advector ( x )
location <-  advector ( location )
scale <-  advector ( scale )
log <-  as.logical ( log )
distr_dlogis ( x, location, scale, log )
}
)
##' @describeIn Distributions Default method
setMethod("dlogis",
signature(x = "num", location = "num.", scale = "num.", log = "logical."),
function( x, location, scale, log ) {
stats:: dlogis ( x=x, location=location, scale=scale, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dlogis", "osa",
function( x, location, scale, log ) {
  dGenericOSA( "dlogis" , x=x, location=location, scale=scale, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dlogis", "simref",
function( x, location, scale, log ) {
  dGenericSim( "dlogis" , x=x, location=location, scale=scale, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{dt}
setMethod("dt",
signature(x = "ad", df = "ad", ncp = "missing", log = "logical."),
function( x, df, log ) {
x <-  advector ( x )
df <-  advector ( df )
log <-  as.logical ( log )
distr_dt ( x, df, log )
}
)
##' @describeIn Distributions Default method
setMethod("dt",
signature(x = "num", df = "num", ncp = "missing", log = "logical."),
function( x, df, log ) {
stats:: dt ( x=x, df=df, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dt", "osa",
function( x, df, log ) {
  dGenericOSA( "dt" , x=x, df=df, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dt", "simref",
function( x, df, log ) {
  dGenericSim( "dt" , x=x, df=df, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{dnbinom}
setMethod("dnbinom",
signature(x = "ad", size = "ad", prob = "ad", mu = "missing", log = "logical."),
function( x, size, prob, log ) {
x <-  advector ( x )
size <-  advector ( size )
prob <-  advector ( prob )
log <-  as.logical ( log )
distr_dnbinom ( x, size, prob, log )
}
)
##' @describeIn Distributions Default method
setMethod("dnbinom",
signature(x = "num", size = "num", prob = "num", mu = "missing", log = "logical."),
function( x, size, prob, log ) {
stats:: dnbinom ( x=x, size=size, prob=prob, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dnbinom", "osa",
function( x, size, prob, log ) {
  dGenericOSA( "dnbinom" , x=x, size=size, prob=prob, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dnbinom", "simref",
function( x, size, prob, log ) {
  dGenericSim( "dnbinom" , x=x, size=size, prob=prob, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{dpois}
setMethod("dpois",
signature(x = "ad", lambda = "ad", log = "logical."),
function( x, lambda, log ) {
x <-  advector ( x )
lambda <-  advector ( lambda )
log <-  as.logical ( log )
distr_dpois ( x, lambda, log )
}
)
##' @describeIn Distributions Default method
setMethod("dpois",
signature(x = "num", lambda = "num", log = "logical."),
function( x, lambda, log ) {
stats:: dpois ( x=x, lambda=lambda, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dpois", "osa",
function( x, lambda, log ) {
  dGenericOSA( "dpois" , x=x, lambda=lambda, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dpois", "simref",
function( x, lambda, log ) {
  dGenericSim( "dpois" , x=x, lambda=lambda, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{dgamma}
setMethod("dgamma",
signature(x = "ad", shape = "ad", rate = "missing", scale = "ad.", log = "logical."),
function( x, shape, scale, log ) {
x <-  advector ( x )
shape <-  advector ( shape )
scale <-  advector ( scale )
log <-  as.logical ( log )
distr_dgamma ( x, shape, scale, log )
}
)
##' @describeIn Distributions Default method
setMethod("dgamma",
signature(x = "num", shape = "num", rate = "missing", scale = "num.", log = "logical."),
function( x, shape, scale, log ) {
stats:: dgamma ( x=x, shape=shape, scale=scale, log=log )
}
)
##' @describeIn Distributions OSA implementation
setMethod("dgamma", "osa",
function( x, shape, scale, log ) {
  dGenericOSA( "dgamma" , x=x, shape=shape, scale=scale, log=log )
}
)
##' @describeIn Distributions Simulation implementation. Modifies \code{x} and returns zero.
setMethod("dgamma", "simref",
function( x, shape, scale, log ) {
  dGenericSim( "dgamma" , x=x, shape=shape, scale=scale, log=log )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{pnorm}
setMethod("pnorm",
signature(q = "ad", mean = "ad.", sd = "ad.", lower.tail = "missing", log.p = "missing"),
function( q, mean , sd  ) {
q <-  advector ( q )
mean <-  advector ( mean )
sd <-  advector ( sd )
distr_pnorm ( q, mean , sd  )
}
)
##' @describeIn Distributions Default method
setMethod("pnorm",
signature(q = "num", mean = "num.", sd = "num.", lower.tail = "missing", log.p = "missing"),
function( q, mean , sd  ) {
stats:: pnorm ( q=q, mean=mean, sd=sd )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{pgamma}
setMethod("pgamma",
signature(q = "ad", shape = "ad", rate = "missing", scale = "ad.", lower.tail = "missing", log.p = "missing"),
function( q, shape, scale  ) {
q <-  advector ( q )
shape <-  advector ( shape )
scale <-  advector ( scale )
distr_pgamma ( q, shape, scale  )
}
)
##' @describeIn Distributions Default method
setMethod("pgamma",
signature(q = "num", shape = "num", rate = "missing", scale = "num.", lower.tail = "missing", log.p = "missing"),
function( q, shape, scale  ) {
stats:: pgamma ( q=q, shape=shape, scale=scale )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{ppois}
setMethod("ppois",
signature(q = "ad", lambda = "ad", lower.tail = "missing", log.p = "missing"),
function( q, lambda ) {
q <-  advector ( q )
lambda <-  advector ( lambda )
distr_ppois ( q, lambda )
}
)
##' @describeIn Distributions Default method
setMethod("ppois",
signature(q = "num", lambda = "num", lower.tail = "missing", log.p = "missing"),
function( q, lambda ) {
stats:: ppois ( q=q, lambda=lambda )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{pexp}
setMethod("pexp",
signature(q = "ad", rate = "ad.", lower.tail = "missing", log.p = "missing"),
function( q, rate ) {
q <-  advector ( q )
rate <-  advector ( rate )
distr_pexp ( q, rate )
}
)
##' @describeIn Distributions Default method
setMethod("pexp",
signature(q = "num", rate = "num.", lower.tail = "missing", log.p = "missing"),
function( q, rate ) {
stats:: pexp ( q=q, rate=rate )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{pweibull}
setMethod("pweibull",
signature(q = "ad", shape = "ad", scale = "ad.", lower.tail = "missing", log.p = "missing"),
function( q, shape, scale ) {
q <-  advector ( q )
shape <-  advector ( shape )
scale <-  advector ( scale )
distr_pweibull ( q, shape, scale )
}
)
##' @describeIn Distributions Default method
setMethod("pweibull",
signature(q = "num", shape = "num", scale = "num.", lower.tail = "missing", log.p = "missing"),
function( q, shape, scale ) {
stats:: pweibull ( q=q, shape=shape, scale=scale )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{pbeta}
setMethod("pbeta",
signature(q = "ad", shape1 = "ad", shape2 = "ad", ncp = "missing", lower.tail = "missing", log.p = "missing"),
function( q, shape1, shape2 ) {
q <-  advector ( q )
shape1 <-  advector ( shape1 )
shape2 <-  advector ( shape2 )
distr_pbeta ( q, shape1, shape2 )
}
)
##' @describeIn Distributions Default method
setMethod("pbeta",
signature(q = "num", shape1 = "num", shape2 = "num", ncp = "missing", lower.tail = "missing", log.p = "missing"),
function( q, shape1, shape2 ) {
stats:: pbeta ( q=q, shape1=shape1, shape2=shape2 )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{qnorm}
setMethod("qnorm",
signature(p = "ad", mean = "ad.", sd = "ad.", lower.tail = "missing", log.p = "missing"),
function( p, mean , sd  ) {
p <-  advector ( p )
mean <-  advector ( mean )
sd <-  advector ( sd )
distr_qnorm ( p, mean , sd  )
}
)
##' @describeIn Distributions Default method
setMethod("qnorm",
signature(p = "num", mean = "num.", sd = "num.", lower.tail = "missing", log.p = "missing"),
function( p, mean , sd  ) {
stats:: qnorm ( p=p, mean=mean, sd=sd )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{qgamma}
setMethod("qgamma",
signature(p = "ad", shape = "ad", rate = "missing", scale = "ad.", lower.tail = "missing", log.p = "missing"),
function( p, shape, scale  ) {
p <-  advector ( p )
shape <-  advector ( shape )
scale <-  advector ( scale )
distr_qgamma ( p, shape, scale  )
}
)
##' @describeIn Distributions Default method
setMethod("qgamma",
signature(p = "num", shape = "num", rate = "missing", scale = "num.", lower.tail = "missing", log.p = "missing"),
function( p, shape, scale  ) {
stats:: qgamma ( p=p, shape=shape, scale=scale )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{qexp}
setMethod("qexp",
signature(p = "ad", rate = "ad.", lower.tail = "missing", log.p = "missing"),
function( p, rate ) {
p <-  advector ( p )
rate <-  advector ( rate )
distr_qexp ( p, rate )
}
)
##' @describeIn Distributions Default method
setMethod("qexp",
signature(p = "num", rate = "num.", lower.tail = "missing", log.p = "missing"),
function( p, rate ) {
stats:: qexp ( p=p, rate=rate )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{qweibull}
setMethod("qweibull",
signature(p = "ad", shape = "ad", scale = "ad.", lower.tail = "missing", log.p = "missing"),
function( p, shape, scale ) {
p <-  advector ( p )
shape <-  advector ( shape )
scale <-  advector ( scale )
distr_qweibull ( p, shape, scale )
}
)
##' @describeIn Distributions Default method
setMethod("qweibull",
signature(p = "num", shape = "num", scale = "num.", lower.tail = "missing", log.p = "missing"),
function( p, shape, scale ) {
stats:: qweibull ( p=p, shape=shape, scale=scale )
}
)
##' @describeIn Distributions AD implementation of \link[stats]{qbeta}
setMethod("qbeta",
signature(p = "ad", shape1 = "ad", shape2 = "ad", ncp = "missing", lower.tail = "missing", log.p = "missing"),
function( p, shape1, shape2 ) {
p <-  advector ( p )
shape1 <-  advector ( shape1 )
shape2 <-  advector ( shape2 )
distr_qbeta ( p, shape1, shape2 )
}
)
##' @describeIn Distributions Default method
setMethod("qbeta",
signature(p = "num", shape1 = "num", shape2 = "num", ncp = "missing", lower.tail = "missing", log.p = "missing"),
function( p, shape1, shape2 ) {
stats:: qbeta ( p=p, shape1=shape1, shape2=shape2 )
}
)
##' @describeIn Distributions AD implementation of \link[base]{besselK}
setMethod("besselK",
signature(x = "ad", nu = "ad", expon.scaled = "missing"),
function( x, nu ) {
x <-  advector ( x )
nu <-  advector ( nu )
distr_besselK ( x, nu )
}
)
##' @describeIn Distributions Default method
setMethod("besselK",
signature(x = "num", nu = "num", expon.scaled = "missing"),
function( x, nu ) {
base:: besselK ( x=x, nu=nu )
}
)
##' @describeIn Distributions AD implementation of \link[base]{besselI}
setMethod("besselI",
signature(x = "ad", nu = "ad", expon.scaled = "missing"),
function( x, nu ) {
x <-  advector ( x )
nu <-  advector ( nu )
distr_besselI ( x, nu )
}
)
##' @describeIn Distributions Default method
setMethod("besselI",
signature(x = "num", nu = "num", expon.scaled = "missing"),
function( x, nu ) {
base:: besselI ( x=x, nu=nu )
}
)
##' @describeIn Distributions AD implementation of \link[base]{besselJ}
setMethod("besselJ",
signature(x = "ad", nu = "ad"),
function( x, nu ) {
x <-  advector ( x )
nu <-  advector ( nu )
distr_besselJ ( x, nu )
}
)
##' @describeIn Distributions Default method
setMethod("besselJ",
signature(x = "num", nu = "num"),
function( x, nu ) {
base:: besselJ ( x=x, nu=nu )
}
)
##' @describeIn Distributions AD implementation of \link[base]{besselY}
setMethod("besselY",
signature(x = "ad", nu = "ad"),
function( x, nu ) {
x <-  advector ( x )
nu <-  advector ( nu )
distr_besselY ( x, nu )
}
)
##' @describeIn Distributions Default method
setMethod("besselY",
signature(x = "num", nu = "num"),
function( x, nu ) {
base:: besselY ( x=x, nu=nu )
}
)
##' @describeIn Distributions AD implementation
dbinom_robust <- function( x, size, logit_p, log ) {
if (inherits(x,"osa")) return (dGenericOSA( "dbinom_robust" , x=x, size=size, logit_p=logit_p, log=log ))
if (inherits(x,"simref")) return (dGenericSim( "dbinom_robust" , x=x, size=size, logit_p=logit_p, log=log ))
x <-  advector ( x )
size <-  advector ( size )
logit_p <-  advector ( logit_p )
log <-  as.logical ( log )
distr_dbinom_robust ( x, size, logit_p, log )
}
##' @describeIn Distributions AD implementation
dsn <- function( x, alpha, log ) {
if (inherits(x,"osa")) return (dGenericOSA( "dsn" , x=x, alpha=alpha, log=log ))
if (inherits(x,"simref")) return (dGenericSim( "dsn" , x=x, alpha=alpha, log=log ))
x <-  advector ( x )
alpha <-  advector ( alpha )
log <-  as.logical ( log )
distr_dsn ( x, alpha, log )
}
##' @describeIn Distributions AD implementation
dSHASHo <- function( x, mu, sigma, nu, tau, log ) {
if (inherits(x,"osa")) return (dGenericOSA( "dSHASHo" , x=x, mu=mu, sigma=sigma, nu=nu, tau=tau, log=log ))
if (inherits(x,"simref")) return (dGenericSim( "dSHASHo" , x=x, mu=mu, sigma=sigma, nu=nu, tau=tau, log=log ))
x <-  advector ( x )
mu <-  advector ( mu )
sigma <-  advector ( sigma )
nu <-  advector ( nu )
tau <-  advector ( tau )
log <-  as.logical ( log )
distr_dSHASHo ( x, mu, sigma, nu, tau, log )
}
##' @describeIn Distributions AD implementation
dtweedie <- function( x, mu, phi, p, log ) {
if (inherits(x,"osa")) return (dGenericOSA( "dtweedie" , x=x, mu=mu, phi=phi, p=p, log=log ))
if (inherits(x,"simref")) return (dGenericSim( "dtweedie" , x=x, mu=mu, phi=phi, p=p, log=log ))
x <-  advector ( x )
mu <-  advector ( mu )
phi <-  advector ( phi )
p <-  advector ( p )
log <-  as.logical ( log )
distr_dtweedie ( x, mu, phi, p, log )
}
##' @describeIn Distributions AD implementation
dnbinom2 <- function( x, mu, var, log ) {
if (inherits(x,"osa")) return (dGenericOSA( "dnbinom2" , x=x, mu=mu, var=var, log=log ))
if (inherits(x,"simref")) return (dGenericSim( "dnbinom2" , x=x, mu=mu, var=var, log=log ))
x <-  advector ( x )
mu <-  advector ( mu )
var <-  advector ( var )
log <-  as.logical ( log )
distr_dnbinom2 ( x, mu, var, log )
}
##' @describeIn Distributions AD implementation
dnbinom_robust <- function( x, log_mu, log_var_minus_mu, log ) {
if (inherits(x,"osa")) return (dGenericOSA( "dnbinom_robust" , x=x, log_mu=log_mu, log_var_minus_mu=log_var_minus_mu, log=log ))
if (inherits(x,"simref")) return (dGenericSim( "dnbinom_robust" , x=x, log_mu=log_mu, log_var_minus_mu=log_var_minus_mu, log=log ))
x <-  advector ( x )
log_mu <-  advector ( log_mu )
log_var_minus_mu <-  advector ( log_var_minus_mu )
log <-  as.logical ( log )
distr_dnbinom_robust ( x, log_mu, log_var_minus_mu, log )
}
##' @describeIn Distributions AD implementation
dlgamma <- function( x, shape, scale, log ) {
if (inherits(x,"osa")) return (dGenericOSA( "dlgamma" , x=x, shape=shape, scale=scale, log=log ))
if (inherits(x,"simref")) return (dGenericSim( "dlgamma" , x=x, shape=shape, scale=scale, log=log ))
x <-  advector ( x )
shape <-  advector ( shape )
scale <-  advector ( scale )
log <-  as.logical ( log )
distr_dlgamma ( x, shape, scale, log )
}
compois_calc_logZ <- function( loglambda, nu ) {
loglambda <-  advector ( loglambda )
nu <-  advector ( nu )
distr_compois_calc_logZ ( loglambda, nu )
}
compois_calc_loglambda <- function( logmean, nu ) {
logmean <-  advector ( logmean )
nu <-  advector ( nu )
distr_compois_calc_loglambda ( logmean, nu )
}
